package org.diligentproject.searchservice.clients;

import java.io.BufferedWriter;
import java.io.FileWriter;

import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.diligentproject.searchservice.searchmasterservice.stubs.service.SearchMasterServiceAddressingLocator;
import org.diligentproject.searchservice.searchmasterservice.stubs.SearchMasterPortType;

public class SearchMasterClient {
	static String serviceURI=null;
	static boolean search=false;
	static String query=null;
	static String outFile=null;
	
	public static void main(String []args) throws Exception{
		try{
			if(!parseInput(args)){
				System.out.println("-location <host>:<port> [ -config | -search -query <query> -output <filename> ]");
				return;
			}
			
			EndpointReferenceType endpoint = new EndpointReferenceType();
			endpoint.setAddress(new Address(serviceEndPoint()));
			
			SearchMasterServiceAddressingLocator serviceLocator = new SearchMasterServiceAddressingLocator();
			SearchMasterPortType pt=serviceLocator.getSearchMasterPortTypePort(endpoint);
			
			if(!search){
				System.out.println(pt.retrieveConfiguration("collections"));
			}
			else{
				writeFile(pt.search(query),outFile);
			}
		}catch (Exception e){
			e.printStackTrace();
		}
	}

	private static boolean parseInput(String []args){
		try{
			for (int i=0;i<args.length;i+=1){
				if (args[i].equalsIgnoreCase("-location")){
					if(serviceURI!=null) return false;
					i+=1;
					serviceURI=args[i];
				}
				if (args[i].equalsIgnoreCase("-config")){
					i+=1;
					search=false;
				}
				if (args[i].equalsIgnoreCase("-search")){
					i+=1;
					search=true;
				}
				if (args[i].equalsIgnoreCase("-output")){
					if(outFile!=null) return false;
					i+=1;
					outFile=args[i];
				}
				if (args[i].equalsIgnoreCase("-query")){
					if(query!=null) return false;
					i+=1;
					query=args[i];
				}
			}
			if (serviceURI==null || (search && (outFile==null || query ==null))) return false;
			return true;
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
	}
	
	private static void writeFile(String text,String filename) throws Exception{
		FileWriter fw=new FileWriter(filename);
		BufferedWriter bw=new BufferedWriter(fw);
		bw.write(text);
		bw.close();
		fw.close();
	}
	
	private static String serviceEndPoint(){
		return "http://"+serviceURI+"/wsrf/services/diligentproject/searchservice/SearchMasterService";
	}
}
